#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#define RAND_MAX 32112656

int strLen(char * str);
bool strEql(char * str1, char * str2);
char * randKey(int len);
int randInt(int low, int high, int base);

int main(int argc, char * argv[]) {
FILE * inFile, * outFile, * keyFile;
int i,j;
bool invalid = false;
int inLen = 0, keyLen = 0;
char * key = 0, * keyFilePath = 0, * input = 0, * inFilePath = 0, * output, * outFilePath = 0;
for (i=0;i<argc;i++) {
if (strEql(argv[i],"-k") && i < argc - 1) {
key = new char[strLen(argv[i+1]) + 1];
sscanf(argv[i+1], "%s", key);
}
if (strEql(argv[i],"-kf") && i < argc - 1) {
keyFilePath = new char[strLen(argv[i+1]) + 1];
sscanf(argv[i+1], "%s", keyFilePath);
}
if (strEql(argv[i],"-i") && i < argc - 1) {
inLen = strLen(argv[i+1]);
input = new char[inLen + 1];
sscanf(argv[i+1], "%s", input);
}
if (strEql(argv[i],"-if") && i < argc - 1) {
inFilePath = new char[strLen(argv[i+1]) + 1];
sscanf(argv[i+1], "%s", inFilePath);
}
if (strEql(argv[i],"-of") && i < argc - 1) {
outFilePath = new char[strLen(argv[i+1]) + 1];
sscanf(argv[i+1], "%s", outFilePath);
}
if (strEql(argv[i],"-kl") && i < argc - 1) {
sscanf(argv[i+1], "%d", &keyLen);
}
if (i >= argc - 1 && (strEql(argv[i],"-k") || strEql(argv[i],"-kf") || strEql(argv[i],"-i") || strEql(argv[i],"-if") || strEql(argv[i],"-of") || strEql(argv[i],"-kl"))) invalid = true;
}
if ((input != 0 && inFilePath != 0) || (input == 0 && inFilePath == 0)) invalid = true;
if ((key != 0 && keyFilePath != 0) || (key != 0 &&  keyLen != 0) || (keyFilePath != 0 && keyLen != 0)) invalid = true;
if (invalid) {
printf("Incorrect syntax. The proper usage is as follows.\n\nxorcrypt options...\n\n-i\t\tInput String\n-if\t\tInput File\n-of\t\tOutput File (If not specified, output will be printed to\n\t\tscreen)\n-k\t\tKey String\n-kf\t\tKey File\n-kl\t\tKey Length - Default is 16 (Somewhat secure)\n\nPlease note that either -i or -if must be specified, but not both. Also, not\nmore than one of -k, -kf, or -kl can be specified.\n");
return 0;
}
if (inFilePath != 0) {
inFile = fopen(inFilePath, "rb");
if (!inFile) {
printf("XOR Crypt could not read from the input file specified with -if. Using -if parameter as raw input instead of as a path to an input file.\n");
inLen = strLen(inFilePath);
input = new char[inLen + 1];
sscanf(inFilePath, "%s", input);
} else {
fseek(inFile, 0, SEEK_END);
inLen = ftell(inFile);
input = new char[inLen + 1];
fseek(inFile, 0, SEEK_SET);
fread (input, 1, inLen, inFile);
input[inLen] = '\0';
fclose(inFile);
}}

if (keyFilePath != 0) {
keyFile = fopen(keyFilePath, "rb");
if (!keyFile) {
printf("XOR Crypt could not read from the key file specified with -kf. Using -kf parameter as raw key instead of as a path to a key file.\n");
key = new char[strLen(keyFilePath) + 1];
sscanf(keyFilePath, "%s", key);
} else {
fseek (keyFile, 0, SEEK_END);
int keyLen = ftell(keyFile);
key = new char[keyLen + 1];
fseek(keyFile, 0, SEEK_SET);
fread (key, 1, keyLen, keyFile);
key[keyLen] = '\0';
fclose(keyFile);
}}
output = new char[inLen + 1];
if (key != 0) keyLen = strLen(key);
if (key == 0) {
if (keyLen == 0) keyLen = 16;
key = randKey(keyLen);
}
for (i=0;i<inLen;i++) {
output[i] = input[i] ^ key[i % strLen(key)];
}
output[inLen] = '\0';
if (outFilePath != 0) {
outFile = fopen(outFilePath, "wb");
fwrite(output, 1, inLen, outFile);
fclose(outFile);
} else {
printf("Output: %s\n", output);
}
delete [] key;
delete [] keyFile;
delete [] input;
delete [] inFile;
delete [] output;
delete [] outFile;
return 0;
}

int strLen(char * str) {
int i;
for (i=0;1;i++) {
if (str[i] == '\0') return i;
}}

bool strEql(char * str1, char * str2) {
int i;
for (i=0;i<=strLen(str1);i++) {
if (str1[i] != str2[i]) return false;
}
return true;
}

char * randKey(int len) {
int i;
char * out = new char[len + 1];
srand(clock() * (len + 27362) * 347 + 549816);
for (i=0;i<len;i++) out[i] = (char)randInt(33,126,i);
out[len] = '\0';
printf("Key: %s\n", out);
return out;
}

int randInt(int low, int high, int base) {
int ret = rand() % (high - low + 1) + low;
return ret;
}
